#include <windows.h>
#include <shlobj.h>
#include "out.h"

#define NULL_VERSION "v1.0 (x86)"

int getwrittentime();

static int last_pause = 0;

int srate, nch, bps;
bool initialized;
unsigned long start_time;
double decoded_seconds, sec_mul;

// -------------------------------------

static int print_speed()
{
    unsigned long cur_time = GetTickCount();
    double total_time = (double)(cur_time - start_time) / 1000.0;

    if ( cur_time < start_time ) total_time = (double)(cur_time + (((__int64)1<<32) - start_time)) / 1000.0;

    if ( decoded_seconds == 0.0 || total_time == 0.0 ) return 0;

    double speed = decoded_seconds / total_time;
    int x = (int)(speed * 100.);

    char temp[1024];
    wsprintf ( temp, "decoding took %u milliseconds, speed %i.%02ix", (unsigned int)(total_time * 1000. + 0.5), x/100, x%100 );

    MessageBox ( 0, temp, "Speed Meter", MB_OK );

    return 1;
}

void about ( HWND hwnd )
{
    MessageBox ( hwnd, "Speed Meter - Winamp decode speed tester " NULL_VERSION "\n"
                       "Copyright (c) 2003 Case\n",
                       "About", MB_OK );
}

void config ( HWND hwnd )
{
}

void init()
{
}

void quit()
{
}

int open ( int samplerate, int numchannels, int bitspersamp, int bufferlenms, int prebufferms )
{
    initialized = false;
    srate = samplerate;
    nch = numchannels;
    bps = bitspersamp;
    sec_mul = (double)1.0 / ((double)srate * (double)nch * (double)(bps/8));

    return 0;
}

void close()
{
    if ( initialized ) print_speed();
}

int write ( char *buf, int len )
{
    if ( !initialized ) {
        decoded_seconds = 0;
        initialized = true;
        start_time = GetTickCount();
    }

    decoded_seconds += (double)len * sec_mul;

    return 0;
}

int canwrite()
{
    return last_pause ? 0 : 16*1024*1024;
}

int isplaying()
{
    return 0;
}

int pause ( int pause )
{
    int t = last_pause;
    last_pause = pause;
    return t;
}

void setvolume ( int volume )
{
}

void setpan ( int pan )
{
}

void flush ( int t )
{
}
    
int getwrittentime()
{
    return (int)(decoded_seconds * 1000.0);
}

Out_Module out = {
    OUT_VER,
    "Speed Meter " NULL_VERSION,
    33,
    0, // hmainwindow
    0, // hdllinstance
    config,
    about,
    init,
    quit,
    open,
    close,
    write,
    canwrite,
    isplaying,
    pause,
    setvolume,
    setpan,
    flush,
    getwrittentime,
    getwrittentime
};

extern "C" {

__declspec (dllexport) Out_Module *winampGetOutModule()
{
    return &out;
}

}
